package org.stm.bcs.streTest.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.stm.bcs.streTest.entity.BcsStreTest;
import org.stm.bcs.streTest.service.IBcsStreTestService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 科技事件压力测试
 * @Author: jeecg-boot
 * @Date:   2025-10-07
 * @Version: V1.0
 */
@Api(tags="科技事件压力测试")
@RestController
@RequestMapping("/bcs.streTest/bcsStreTest")
@Slf4j
public class BcsStreTestController extends JeecgController<BcsStreTest, IBcsStreTestService> {
	@Autowired
	private IBcsStreTestService bcsStreTestService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsStreTest
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "科技事件压力测试-分页列表查询")
	@ApiOperation(value="科技事件压力测试-分页列表查询", notes="科技事件压力测试-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BcsStreTest>> queryPageList(BcsStreTest bcsStreTest,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsStreTest> queryWrapper = QueryGenerator.initQueryWrapper(bcsStreTest, req.getParameterMap());
		Page<BcsStreTest> page = new Page<BcsStreTest>(pageNo, pageSize);
		String [] rangeIssuedTimes = req.getParameterMap().get("rangeIssuedTime[]");
		if(rangeIssuedTimes!=null&&rangeIssuedTimes.length>0){
			if(rangeIssuedTimes.length==1){
				String kssjtemp=rangeIssuedTimes[0].replaceAll("\"","");
				String kssj =kssjtemp.substring(0,11);
				queryWrapper.eq("sttime",kssj);


			}else{
				String kssjtemp=rangeIssuedTimes[0].replaceAll("\"","");;
				String kssj =kssjtemp.substring(0,11);
				String endtemp=rangeIssuedTimes[1].replaceAll("\"","");;
				String endsj =endtemp.substring(0,11);
				queryWrapper.between("sttime", kssj, endsj);
			}
		}
		IPage<BcsStreTest> pageList = bcsStreTestService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsStreTest
	 * @return
	 */
	@AutoLog(value = "科技事件压力测试-添加")
	@ApiOperation(value="科技事件压力测试-添加", notes="科技事件压力测试-添加")
	@RequiresPermissions("bcs.streTest:bcs_stre_test:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BcsStreTest bcsStreTest) {
		bcsStreTest.setExeSta("0");
		bcsStreTestService.save(bcsStreTest);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsStreTest
	 * @return
	 */
	@AutoLog(value = "科技事件压力测试-编辑")
	@ApiOperation(value="科技事件压力测试-编辑", notes="科技事件压力测试-编辑")
	@RequiresPermissions("bcs.streTest:bcs_stre_test:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsStreTest bcsStreTest) {
		bcsStreTestService.updateById(bcsStreTest);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "科技事件压力测试-通过id删除")
	@ApiOperation(value="科技事件压力测试-通过id删除", notes="科技事件压力测试-通过id删除")
	@RequiresPermissions("bcs.streTest:bcs_stre_test:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsStreTestService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "科技事件压力测试-批量删除")
	@ApiOperation(value="科技事件压力测试-批量删除", notes="科技事件压力测试-批量删除")
	@RequiresPermissions("bcs.streTest:bcs_stre_test:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsStreTestService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "科技事件压力测试-通过id查询")
	@ApiOperation(value="科技事件压力测试-通过id查询", notes="科技事件压力测试-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BcsStreTest> queryById(@RequestParam(name="id",required=true) String id) {
		BcsStreTest bcsStreTest = bcsStreTestService.getById(id);
		if(bcsStreTest==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsStreTest);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsStreTest
    */
    @RequiresPermissions("bcs.streTest:bcs_stre_test:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsStreTest bcsStreTest) {
        return super.exportXls(request, bcsStreTest, BcsStreTest.class, "科技事件压力测试");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("bcs.streTest:bcs_stre_test:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsStreTest.class);
    }

}
